import 'package:flutter_gadgets_2/flutter_gadgets_2.dart';

import '../model/game.dart';
import '../view/my_game_view.dart';

class MyGameViewController extends ControllerGadget {
  void onResetPressed() {
    final game = model.getValue<Game>()!;
    game.newGame();
    final viewModel = model.getValue<MyGameViewModel>()!;
    viewModel.controller.clear();
    viewModel.errorMessage = null;
    viewModel.canPlay = true;
    model.notifyFor<MyGameViewModel>();
    model.notifyFor<Game>();
  }

  void onNextTurnPressed() {
    final viewModel = model.getValue<MyGameViewModel>()!;
    final value = viewModel.controller.text.trim();
    if (value.isEmpty) {
      viewModel.errorMessage = 'You must insert a number.';
      model.notifyFor<MyGameViewModel>();
      return;
    }
    final parsedValue = int.tryParse(value);
    if (parsedValue == null) {
      viewModel.errorMessage = 'You must insert a valid number.';
      model.notifyFor<MyGameViewModel>();
      return;
    } else if (parsedValue < 1 || parsedValue > 100) {
      viewModel.errorMessage = 'The value must be between 1 and 100.';
      model.notifyFor<MyGameViewModel>();
      return;
    } else {
      final game = model.getValue<Game>()!;
      game.nextTurn(parsedValue);
      viewModel.errorMessage = null;
      if (game.numberFound) {
        viewModel.controller.clear();
        viewModel.canPlay = false;
      }
      model.notifyFor<MyGameViewModel>();
      model.notifyFor<Game>();
    }
  }
}
