import 'package:flutter/material.dart';
import 'package:flutter_gadgets_2/flutter_gadgets_2.dart';

import '../controller/my_welcome_view_controller.dart';

class MyWelcomeViewModel {
  late TextEditingController controller;
  String? errorText;
}

class MyWelcomeView extends StatelessWidget {
  const MyWelcomeView({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return ViewGadget<MyWelcomeViewController>(
      controller: MyWelcomeViewController(),
      builder: (_, controller) => ViewModelGadget<MyWelcomeViewModel>(
        viewModel: MyWelcomeViewModel(),
        init: (viewModel) => viewModel.controller = TextEditingController(),
        dispose: (viewModel) => viewModel.controller.dispose(),
        builder: (_, viewModel) {
          return Scaffold(
            appBar: AppBar(
              title: const Text('Number Guess'),
              centerTitle: false,
            ),
            body: Padding(
              padding: const EdgeInsets.all(8),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                  SubscriberGadget<MyWelcomeViewModel>(
                    builder: (_, viewModel) => TextField(
                      controller: viewModel.controller,
                      decoration: InputDecoration(
                        labelText: 'Name',
                        hintText: 'Enter your name',
                        errorText: viewModel.errorText,
                      ),
                    ),
                  ),
                ],
              ),
            ),
            floatingActionButton: FloatingActionButton(
              onPressed: controller.onFabPressed,
              child: const Icon(Icons.arrow_right_alt),
            ),
          );
        },
      ),
    );
  }
}
