import 'package:flutter_gadgets_2/flutter_gadgets_2.dart';
import 'package:flutter_test/flutter_test.dart';

import '../utils.dart';

void main() {
  group('ObservableModel', () {
    const token = 'token';
    final observableModel = ObservableModel();
    final mockBean = MockValue();
    final mockBeanWithToken = MockValue();

    observableModel.putValue<MockValue>(value: mockBean);
    observableModel.putValue<MockValue>(value: mockBeanWithToken, token: token);
  
    test('get without token', () {
      expect(observableModel.getValue<MockValue>(), mockBean);
    });
    test('get with token', () {
      expect(observableModel.getValue<MockValue>(token: token), mockBeanWithToken);
    });
    test('remove bean with token', () {
      observableModel.removeValue<MockValue>(token: token);
      expect(observableModel.getValue<MockValue>(token: token), null);
      expect(observableModel.getValue<MockValue>(), mockBean);
    });
    test('dispose', () {
      observableModel.dispose();
      expect(observableModel.getValue<MockValue>(), null);
    });
  });
}
