import 'package:flutter/material.dart';
import 'package:flutter_gadgets_2/flutter_gadgets_2.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';

import '../utils.dart';

void main() {
  testWidgets('ViewModelGadget test', (tester) async {
    await tester.pumpWidget(
      AppGadget(
        child: ViewModelGadget(
          viewModel: MockViewModel(),
          init: (MockViewModel viewModel) => viewModel.state = 10,
          builder: (_, __) => Container(),
        ),
      ),
    );
    final viewModel = Provider.of<ObservableModel>(
      tester.element(find.byType(Container)),
      listen: false,
    ).getValue<MockViewModel>();
    expect(viewModel, isNotNull);
    expect(viewModel!.state, 10);
  });
}
